Package ec.breed

# Class ForceBreedingPipeline

java.lang.Object
ec.BreedingSource
ec.BreedingPipeline
ec.breed.ForceBreedingPipeline

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class ForceBreedingPipeline extends BreedingPipeline
ForceBreedingPipeline has one source. To fill its quo for produce(...), ForceBreedingPipeline repeatedly forces its source to produce exactly numInds individuals at a time, except possibly the last time, where the number of individuals its source produces may be as low as 1. This is useful for forcing Crossover to produce only one individual, or mutation to produce 2 individuals always, etc.

Typical Number of Individuals Produced Per `produce(...)` call
Determined by base.`num-inds`

Number of Sources
1

Parameters

base.`num-inds` int >= 1 | (The number of individuals this breeding pipeline will force its source to produce each time in order to fill the quo for produce(...).)

Default Base
breed.force

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `int`
  `numInds`
  `static final String`
  `P_FORCE`
  `static final String`
  `P_NUMINDS`

  ### Fields inherited from class ec.BreedingPipeline

  `DYNAMIC_SOURCES, likelihood, mybase, P_LIKELIHOOD, P_NUMSOURCES, P_SOURCE, sources, V_SAME, V_STUB`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ForceBreedingPipeline()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `int`
  `numSources()`
  Returns the number of sources to this pipeline.
  `int`
  `produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)`
  Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `int`
  `typicalIndsProduced()`
  Returns the max of typicalIndsProduced() of all its children

  ### Methods inherited from class ec.BreedingPipeline

  `clone, fillStubs, finishProducing, individualReplaced, maxChildProduction, minChildProduction, preparePipeline, prepareToProduce, produces, sourcesAreProperForm`

  ### Methods inherited from class ec.BreedingSource

  `getProbability, pickRandom, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_NUMINDS

    public static final String P_NUMINDS
    See Also:
      - Constant Field Values

  - ### P_FORCE

    public static final String P_FORCE
    See Also:
      - Constant Field Values

  - ### numInds

    public int numInds

- ## Constructor Details

  - ### ForceBreedingPipeline

    public ForceBreedingPipeline()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).

  - ### numSources

    public int numSources()
    Description copied from class: `BreedingPipeline`
    Returns the number of sources to this pipeline. Called during BreedingPipeline's setup. Be sure to return a value > 0, or DYNAMIC_SOURCES which indicates that setup should check the parameter file for the parameter "num-sources" to make its determination.
    Specified by:
      `numSources` in class `BreedingPipeline`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingPipeline`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### typicalIndsProduced

    public int typicalIndsProduced()
    Returns the max of typicalIndsProduced() of all its children
    Overrides:
      `typicalIndsProduced` in class `BreedingPipeline`

  - ### produce

    public int produce(int min, int max, int subpopulation, ArrayList<Individual> inds, EvolutionState state, int thread, HashMap<String,Object> misc)
    Description copied from class: `BreedingSource`
    Produces n individuals from the given subpopulation and puts them into inds[start...start+n-1], where n = Min(Max(q,min),max), where q is the "typical" number of individuals the BreedingSource produces in one shot, and returns n. max must be >= min, and min must be >= 1. For example, crossover might typically produce two individuals, tournament selection might typically produce a single individual, etc.
    Specified by:
      `produce` in class `BreedingSource`